﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Net;
using System.ServiceModel.Channels;
using System.ServiceModel;

namespace TestClient
{
    class Program
    {
        static void Main(string[] args)
        {
            string headerName = "RequesterInstanceId";
            string headerNamespace = "http://tempuri.org/Shareable";

            Console.Write("Enter the instance id: ");
            string instanceId = Console.ReadLine();
            while (!String.IsNullOrEmpty(instanceId))
            {
                MessageHeader header = MessageHeader.CreateHeader(headerName, headerNamespace, instanceId);

                using (DemoService.SessionClient proxy = new DemoService.SessionClient())
                {
                    using (new OperationContextScope(proxy.InnerChannel))
                    {
                        //Add the header as a header to the scope so it gets sent for each message.
                        OperationContext.Current.OutgoingMessageHeaders.Add(header);
                        Console.WriteLine(proxy.GetSessionStatus());
                    }
                }
                Console.Write("Enter the instance id: ");
                instanceId = Console.ReadLine();
            }
        }
    }
}
