﻿Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Transactions

Public Class Program

    Public Shared Sub Main()
        AppDomain.CurrentDomain.SetData("DataDirectory", _
            System.IO.Path.GetFullPath(System.IO.Path.Combine(Environment.CurrentDirectory, "..\..\..\..")))
        Console.WriteLine(String.Format("Before starting, the record count is {0}", getRecordCount()))

        Using client As _
            New TransactionalClient.TransactionalServiceProxy.UpdateServiceClient()
            Using ts As New TransactionScope()

                Dim updatedRecords As Integer
                updatedRecords += client.UpdateWithTransaction( _
                    "INSERT INTO DemoTable VALUES (1, 'Demo Data')")
                updatedRecords += client.UpdateWithTransaction( _
                    "INSERT INTO DemoTable VALUES (2, 'More Data')")
                Console.WriteLine(String.Format("The record count is {0}", updatedRecords))

                ts.Dispose()
            End Using

        End Using

        Console.WriteLine(String.Format("After the rollback, the record count is {0}", getRecordCount()))
        Console.ReadLine()
    End Sub


#Region "Private Methods"

    Private Shared Function getRecordCount() As Integer

        Dim result As Integer

        Dim connectionString As String = _
            ConfigurationManager.ConnectionStrings("TK503").ConnectionString

        Using cn As New SqlConnection(connectionString)
            cn.Open()
            Dim cmd As New SqlCommand("SELECT COUNT(*) FROM DemoTable", cn)
            result = Convert.ToInt32(cmd.ExecuteScalar())
        End Using

        Return result
    End Function

#End Region

End Class
