﻿Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Transactions

Public Class Program

    Public Shared Sub Main()
        AppDomain.CurrentDomain.SetData("DataDirectory", _
            System.IO.Path.GetFullPath(System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "..\..\..")))

        Console.WriteLine(String.Format("Before starting, the record count is {0}", getRecordCount()))

        Using client As _
            New TransactionalClient.TransactionalServiceProxy.UpdateServiceClient()

            Try
                Using ts1 As New TransactionScope(TransactionScopeOption.Required)
                    Dim updatedRecords As Integer
                    updatedRecords += client.UpdateWithTransaction( _
                       "INSERT INTO DemoTable VALUES (1, 'Demo Data')")
                    Using ts2 As New TransactionScope()
                        updatedRecords += client.UpdateWithTransaction( _
                           "INSERT INTO DemoTable VALUES (2, 'Demo Data')")
                        ts2.Dispose()
                    End Using
                    ts1.Complete()
                End Using
            Catch ex As Exception
                Console.WriteLine(ex.Message)
            End Try

        End Using

        Console.WriteLine(String.Format("After the rollback, the record count is {0}", getRecordCount()))
        Console.ReadLine()
    End Sub


#Region "Private Methods"

    Private Shared Function getRecordCount() As Integer

        Dim result As Integer

        Dim connectionString As String = _
            ConfigurationManager.ConnectionStrings("TK503").ConnectionString

        Using cn As New SqlConnection(connectionString)
            cn.Open()
            Dim cmd As New SqlCommand("SELECT COUNT(*) FROM DemoTable", cn)
            result = Convert.ToInt32(cmd.ExecuteScalar())
        End Using

        Return result
    End Function

    Private Shared Sub showTransactionDetails(ByVal tsName As String)
        Console.WriteLine(String.Format("For transaction '{0}', the local identifier is {1}", tsName, _
            Transaction.Current.TransactionInformation.LocalIdentifier))
    End Sub

#End Region

End Class
