﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using DemoClient.DemoService;
using System.ServiceModel;

namespace DemoClient
{
    public partial class Form1 : Form
    {
        private delegate void SendMessage(string message);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int numberConcurrentCalls = 0;
            if (int.TryParse(concurrentClientCountTextBox.Text, out numberConcurrentCalls))
                for (int i = 1; i <= numberConcurrentCalls; i++)
                {
                    ParameterizedThreadStart pts = new ParameterizedThreadStart(CallWcfService);
                    Thread t = new Thread(pts);
                    t.Start(i);
                }
        }

        public void CallWcfService(object identifier)
        {
            InstanceContext context = new InstanceContext(this);
            using (DemoService.ConcurrencyClient proxy = new DemoService.ConcurrencyClient(context))
            {
                SendMessage updateMethod = new SendMessage(addToLabel);
                this.Invoke(updateMethod, String.Format("Call {0} Start: {1}", identifier.ToString(), DateTime.Now.ToLongTimeString()));
                this.Invoke(updateMethod, String.Format("Call {0} : {1}", identifier.ToString(), proxy.GetCallCount(5000)));
                this.Invoke(updateMethod, String.Format("Call {0} End: {1}", identifier.ToString(), DateTime.Now.ToLongTimeString()));
            }
        }

        private void addToLabel(string message)
        {
            if (!String.IsNullOrEmpty(label2.Text))
                message = Environment.NewLine + message;
            label2.Text += message;
        }

    }
}
