﻿Imports System.Threading
Imports System.ServiceModel
Imports DemoClient.DemoService

<CallbackBehavior(UseSynchronizationContext:=True)> _
Public Class Form1
    Implements IConcurrencyCallback

    Private Delegate Sub SendMessage(ByVal message As String)

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim numberConcurrentCalls As Integer = 0
        If Integer.TryParse(concurrentClientCountTextBox.Text, numberConcurrentCalls) Then
            For i As Integer = 1 To numberConcurrentCalls
                Dim pts As New ParameterizedThreadStart(AddressOf CallWcfService)
                Dim t As New Thread(pts)
                t.Start(i)
            Next
        End If
    End Sub


    Public Sub CallWcfService(ByVal identifier As Object)
        Dim context As New InstanceContext(Me)
        Using proxy As New DemoService.ConcurrencyClient(context)
            Dim updateMethod As New SendMessage(AddressOf addToLabel)
            Me.Invoke(updateMethod, String.Format("Call {0} Start: {1}", identifier.ToString(), DateTime.Now.ToLongTimeString()))
            Me.Invoke(updateMethod, String.Format("Call {0} : {1}", identifier.ToString(), proxy.GetCallCount(5000)))
            Me.Invoke(updateMethod, String.Format("Call {0} End: {1}", identifier.ToString(), DateTime.Now.ToLongTimeString()))
        End Using
    End Sub

    Private Sub addToLabel(ByVal message As String)

        If Not String.IsNullOrEmpty(label2.Text) Then
            message = Environment.NewLine & message
        End If

        label2.Text += message

    End Sub

    Public Sub ReceiveCallCount(ByVal callCount As Integer) _
        Implements DemoService.IConcurrencyCallback.ReceiveCallCount

        Dim updateMethod As New SendMessage(AddressOf addToLabel)
        Me.Invoke(updateMethod, String.Format("The updated callCount is {0}.", callCount))

    End Sub

End Class
