﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ThreadPoolSynchronization
{
    [Serializable]
    internal class WorkItem
    {
        object state;
        SendOrPostCallback method;
        ManualResetEvent asyncWaitHandle;

        public WaitHandle AsyncWaitHandle
        {
            get
            {
                return asyncWaitHandle;
            }
        }

        internal WorkItem(SendOrPostCallback method, object state)
        {
            this.method = method;
            this.state = state;
            asyncWaitHandle = new ManualResetEvent(false);
        }

        internal void CallBack()
        {
            method(state);
            asyncWaitHandle.Set();
        }
    }
}
