﻿Imports System.Diagnostics
Imports System.Threading

Friend Class WorkerThread

    Dim context As ThreadPoolSynchronizer
    Dim threadObj As Thread
    Dim _endLoop As Boolean

    Public ReadOnly Property ManagerThreadId() As Integer
        Get
            Return threadObj.ManagedThreadId
        End Get
    End Property

 

    Friend Sub New(ByVal threadNumber As Integer, ByVal context As ThreadPoolSynchronizer)
        Me.context = context

        _endLoop = False
        threadObj = New Thread(AddressOf Run)
        threadObj.IsBackground = True
        threadObj.Name = "Tread-" & threadNumber.ToString()
        threadObj.Start()
    End Sub

    Private Property EndLoop() As Boolean

        Set(ByVal value As Boolean)
            SyncLock (Me)
                _endLoop = value
            End SyncLock
        End Set

        Get
            SyncLock (Me)
                Return _endLoop
            End SyncLock
        End Get
    End Property

    Public Sub Start()
        Debug.Assert(threadObj IsNot Nothing)
        Debug.Assert(threadObj.IsAlive = False)
        threadObj.Start()
    End Sub

    Public Sub Run()
        Debug.Assert(SynchronizationContext.Current Is Nothing)
        SynchronizationContext.SetSynchronizationContext(context)

        While _endLoop = False
            Dim _workItem As WorkItem = context.GetNext()
            If _workItem IsNot Nothing Then
                _workItem.CallBack()
            End If
        End While
    End Sub

    Public Sub Abort()
        Debug.Assert(threadObj IsNot Nothing)
        If threadObj.IsAlive = False Then
            Return
        End If
        _endLoop = True

        threadObj.Join()
    End Sub

End Class
