﻿using System;
using System.Collections.Generic;
using System.ServiceModel;

namespace Tasks.Services
{
    [ServiceContract(Name = "TaskManagerService",
                Namespace = "http://schemas.fabrikam.com/2008/04/tasks/")]
    public interface ITaskManagerService
    {
        [OperationContract()]
        int AddTask(string taskDescription, string assignedTo);

        [OperationContract()]
        List<int> GetTasksByAssignedName(string assignedTo);

        [OperationContract()]
        string GetTaskDescription(int taskNumber);

        [OperationContract()]
        bool IsTaskCompleted(int taskNumber);

        [OperationContract(IsOneWay = true)]
        void MarkTaskCompleted(int taskNumber);

        [OperationContract(IsOneWay = true)]
        void DeleteTask(int taskNumber);
    }
}
