﻿Imports System.ServiceModel
Imports System.ServiceModel.Channels
Imports Tasks.Entities
Imports Tasks.Services

Module Module1

    Sub Main()
        Dim binding As Binding
        binding = New BasicHttpBinding

        Dim factory As ChannelFactory(Of ITaskManagerService)
        factory = New ChannelFactory(Of ITaskManagerService)( _
                binding, "http://localhost:8080/Tasks/TaskManager")

        Dim proxy As ITaskManagerService
        proxy = factory.CreateChannel()

        Try
            Dim task As New Task()
            task.CreatedBy = "Vicki"
            task.AssignedTo = "Ian"
            task.DateCreated = DateTime.Now
            task.DateLastModified = DateTime.Now
            task.Description = "Clean your room"
            task.DueDate = DateTime.Now.AddDays(3)

            Dim ack As TaskAcknowledgement
            ack = proxy.AddTask(task)

            Console.WriteLine( _
                "Task number {0} added to service", _
                                    ack.TaskNumber)
        Catch ex As Exception
            Console.WriteLine("Error: {0}", ex.Message)
        End Try
    End Sub

End Module
