﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SvcUtilProxy
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                TaskManagerServiceClient proxy = new TaskManagerServiceClient();

                Task task = new Task();
                task.CreatedBy = "Homer";
                task.AssignedTo = "Lisa";
                task.DateCreated = DateTime.Now;
                task.DateLastModified = DateTime.Now;
                task.Description = "Practice your saxophone";
                task.DueDate = DateTime.Now.AddDays(3);

                AsyncCallback cb = new AsyncCallback(HandleTaskAdded);
                proxy.BeginAddTask(task,cb,proxy);

                Console.WriteLine("Asynchronously adding a task to the service" +
                    "Press any key to exit");

                Console.ReadLine();
            }

            catch (Exception ex)
            {
                Console.WriteLine("Error: {0}", ex.Message);
            }
        }

        static void HandleTaskAdded(IAsyncResult ar)
        {
            TaskManagerServiceClient proxy = ar.AsyncState 
                                        as TaskManagerServiceClient;

            TaskAcknowledgement ack = proxy.EndAddTask(ar);

            Console.WriteLine(
                "Task number {0} was added to service",
                    ack.TaskNumber);
        }
    }
}
