﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

using Tasks.Entities;

namespace Tasks.Services
{
    [ServiceContract(Name = "TaskManagerService",
                    Namespace = "http://schemas.fabrikam.com/2008/04/tasks/")]
    public interface ITaskManagerService
    {
        [OperationContract()]
        TaskAcknowledgement AddTask( Task task);

        [OperationContract()]
        List<Task> GetTasksByAssignedName(string assignedTo);

        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        Task GetTask(int taskNumber);

        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        void MarkTaskCompleted(int taskNumber);

        [OperationContract()]
        [FaultContract(typeof(FaultInfo))]
        void DeleteTask(int taskNumber);
    }
}
