﻿using System;
using System.ServiceModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using VSProxy.Tasks;

namespace VSProxy
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                TaskManagerServiceClient proxy = new TaskManagerServiceClient();

                Task task = new Task();
                task.CreatedBy = "Eric";
                task.AssignedTo = "Vicki";
                task.DateCreated = DateTime.Now;
                task.DateLastModified = DateTime.Now;
                task.Description = "Do the laundry";
                task.DueDate = DateTime.Now.AddDays(3);

                TaskAcknowledgement ack = proxy.AddTask(task);

                int taskNum = ack.TaskNumber;
                Console.WriteLine(
                    "Task number {0} added to service",
                        taskNum);

                // Now try to mark that same task
                // as completed:
                proxy.MarkTaskCompleted(taskNum);
            }

            catch (FaultException<FaultInfo> fault)
            {
                Console.WriteLine("Fault: {0}",fault.Detail.Reason);
            }
        }
    }
}
