﻿using System;
using System.Xml;
using System.Threading;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace HostConsoleApp
{
    [ServiceContract]
    interface IGreetingHandler
    {
        [OperationContract(IsOneWay = true)]
        void GreetingProduced(string greeting);
    }

    [ServiceContract(CallbackContract = typeof(IGreetingHandler))]
    interface IGreetingService
    {
        [OperationContract(IsOneWay = true)]
        void RequestGreeting(string name);
    }

    // Don't worry too much about this "Instancing setting"
    // For now just take away that callback channels, as one
    // would expect, require sessions to be in place between
    // the consumer and the service. You'll learn more about
    // sessions and session management in chapter?
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerSession)]
    class GreetingService : IGreetingService
    {
        public void RequestGreeting(string name)
        {
            Console.WriteLine("In Service.RequestGreeting");
            IGreetingHandler cbh;
            cbh = OperationContext.Current.GetCallbackChannel<IGreetingHandler>();
            cbh.GreetingProduced("Hello " + name);
        }
    }
}