﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace MapPointTestClient
{
    public partial class MainForm : Form
    {
        private const string DefaultDataSourceName = "MapPoint.NA";

        private Dictionary<Address, Bitmap> _cachedMaps = new Dictionary<Address, Bitmap>();

        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            InitAddressInputFields();

            _countriesComboBox.SelectedIndex = 0;
            _recentlyViewedComboBox.ComboBox.DisplayMember = "AddressLine";

            _recentlyViewedComboBox.SelectedIndexChanged += new EventHandler(_recentlyViewedComboBox_SelectedIndexChanged);
        }

        private void _recentlyViewedComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Address addr = _recentlyViewedComboBox.SelectedItem as Address;
            if (addr != null)
            {
                Bitmap bmap = _cachedMaps[addr];
                if (bmap != null)
                    _mainPicBox.Image = bmap;
            }
        }

        private void InitAddressInputFields()
        {
            _tboxAddressLine.Text = string.Empty;
            _tboxCity.Text = string.Empty;
            _tboxProvinceOrState.Text = string.Empty;
            _tboxZipOrPostalCode.Text = string.Empty;
        }

        private void _btnViewMap_Click(object sender, EventArgs e)
        {
        }
    }
}
