﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Channels;
using System.Diagnostics;

namespace DemoService
{
    public class HeaderService : IGetHeaders
    {
        public string GetHeaders()
        {
            if (Trace.CorrelationManager.ActivityId == Guid.Empty)
                Trace.CorrelationManager.ActivityId = Guid.NewGuid();

            TraceSource ts = new TraceSource("DemoServiceTraceSource");
            ts.TraceEvent(TraceEventType.Start, 0, "GetHeader Activity");
            ts.TraceEvent(TraceEventType.Information, 0,
                "Service receives GetHeaders request message.");

            string result = String.Empty;
            int myHeaderIndex = OperationContext.Current.RequestContext.RequestMessage.Headers.FindHeader("MyHeader", "http://tempuri.org");
            if (myHeaderIndex != -1)
                result = OperationContext.Current.RequestContext.RequestMessage.Headers.GetHeader<String>(myHeaderIndex);
            else
                result = OperationContext.Current.RequestContext.RequestMessage.Headers.Action;

            ts.TraceEvent(TraceEventType.Information, 0,
                "Service sends GetHeaders response message.");
            ts.TraceEvent(TraceEventType.Stop, 0, "GetHeader Activity");

            return result;
        }
    }
}
