﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace TestClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Guid newActivityId = Guid.NewGuid();
            Trace.CorrelationManager.ActivityId = newActivityId;
            TraceSource ts = new TraceSource("DemoServiceTraceSource");
            ts.TraceEvent(TraceEventType.Start, 0, "DemoService Activity");

            using (DemoService.GetHeadersClient proxy = new DemoService.GetHeadersClient())
            {
                Guid originalActivityId = Trace.CorrelationManager.ActivityId;
                newActivityId = Guid.NewGuid();
                ts.TraceTransfer(0, "Transfer", newActivityId);
                Trace.CorrelationManager.ActivityId = newActivityId;
                ts.TraceEvent(TraceEventType.Start, 0, "GetHeader Activity");

                ts.TraceEvent(TraceEventType.Information, 0, "Client sending message to DemoService");
                Console.WriteLine("And the headers are: " + proxy.GetHeaders());
                ts.TraceEvent(TraceEventType.Information, 0, "Client received response from DemoService");
                ts.TraceTransfer(667, "Transfer to DemoService Actitity", originalActivityId);
                ts.TraceEvent(TraceEventType.Stop, 0, "GetHeader Activity");
                Trace.CorrelationManager.ActivityId = originalActivityId;
            }
            ts.TraceEvent(TraceEventType.Stop, 0, "DemoService Activity");
            Console.ReadLine();
        }
    }
}
