﻿Imports System.ServiceModel.Dispatcher
Imports System.Text.RegularExpressions

Public Class PhoneNumberParameterValidator
    Implements IParameterInspector

    Dim phoneNumberParamIndex As Integer
    Dim phoneNumberFormat As String = _
        "^(?:\([2-9]\d{2}\)\ ?|[2-9]\d{2}(?:\-?|\ ?))[2-9]\d{2}[- ]?\d{4}$"

    Public Sub New()
        Me.New(0)
    End Sub

    Public Sub New(ByVal phoneNumberParamIndex As Integer)
        Me.phoneNumberParamIndex = phoneNumberParamIndex
    End Sub

    Public Sub AfterCall(ByVal operationName As String, ByVal outputs As Object(), _
        ByVal returnValue As Object, ByVal correlationState As Object) _
        Implements IParameterInspector.AfterCall
    End Sub

    Public Function BeforeCall(ByVal operationName As String, _
        ByVal inputs As Object()) As Object _
        Implements IParameterInspector.BeforeCall

        Dim phoneNumberParam As String = _
           TryCast(inputs(phoneNumberParamIndex), String)

        If Not Regex.IsMatch(phoneNumberParam, phoneNumberFormat, _
          RegexOptions.None) Then
            Throw New FaultException("Invalid phone number. " & _
                        "Required format: ###-###-####")
        End If

        Return Nothing
    End Function

End Class
