﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Channels;
using System.Diagnostics;

namespace DemoService
{
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.Single,
        AddressFilterMode=AddressFilterMode.Any, ValidateMustUnderstand=false)]
    public class RouterService : IRouter
    {
        public void RouteMessage(Message incomingMessage)
        {
            bool customHeaderFound = false;
            foreach (MessageHeaderInfo h in incomingMessage.Headers)
                if (h.Name == "MyHeader")
                    customHeaderFound = true;

            if (!customHeaderFound)
                throw new FaultException<RouterFault>(new RouterFault("Missing a required header", "MyHeader"),
                     new FaultReason("A header is missing"));

            try
            {
                string body = incomingMessage.GetBody<string>();
                Trace.WriteLine(body);
            }
            catch (Exception ex)
            {
                throw new FaultException(new FaultReason("The body is the wrong type"));
            }
        }
    }
}
